'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isFunction = require('zent-utils/lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// 忽略不支持的style
var styleClassMap = {
  info: 'alert-style-info',
  warning: 'alert-style-warning',

  // error as an alias to danger
  error: 'alert-style-danger',
  danger: 'alert-style-danger'
};

// 忽略不支持的size
var sizeClassMap = {
  normal: 'alert-size-normal',
  large: 'alert-size-large'
};

var Alert = (_temp2 = _class = function (_Component) {
  _inherits(Alert, _Component);

  function Alert() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Alert);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Alert.__proto__ || Object.getPrototypeOf(Alert)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      closed: false
    }, _this.onClose = function () {
      _this.setState({
        closed: true
      }, function () {
        // onClose是在*关闭以后*被调用的
        var onClose = _this.props.onClose;

        if ((0, _isFunction2['default'])(onClose)) {
          onClose();
        }
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Alert, [{
    key: 'render',
    value: function render() {
      var _cx;

      var closed = this.state.closed;

      if (closed) {
        return null;
      }

      var _props = this.props,
          type = _props.type,
          prefix = _props.prefix,
          rounded = _props.rounded,
          className = _props.className,
          closable = _props.closable,
          size = _props.size,
          children = _props.children;

      var containerCls = (0, _classnames2['default'])(prefix + '-alert', prefix + '-' + styleClassMap[type], prefix + '-' + sizeClassMap[size], (_cx = {}, _defineProperty(_cx, className, !!className), _defineProperty(_cx, prefix + '-alert-border-rounded', rounded), _defineProperty(_cx, prefix + '-alert-closable', closable), _cx));

      return _react2['default'].createElement(
        'div',
        { className: containerCls },
        closable && _react2['default'].createElement(
          'div',
          { className: prefix + '-alert-close-wrapper' },
          _react2['default'].createElement(
            'span',
            { className: prefix + '-alert-close-btn', onClick: this.onClose },
            '\xD7'
          )
        ),
        _react2['default'].createElement(
          'div',
          { className: prefix + '-alert-content-wrapper' },
          _react2['default'].createElement(
            'div',
            { className: prefix + '-alert-content' },
            children
          )
        )
      );
    }
  }]);

  return Alert;
}(_react.Component), _class.propTypes = {
  type: _react.PropTypes.oneOf(['info', 'warning', 'danger', 'error']).isRequired,
  size: _react.PropTypes.oneOf(['large', 'normal']),
  rounded: _react.PropTypes.bool,
  closable: _react.PropTypes.bool,
  onClose: _react.PropTypes.func,
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  prefix: _react.PropTypes.string
}, _class.defaultProps = {
  type: 'info',
  size: 'normal',
  closable: false,
  rounded: false,
  className: '',
  prefix: 'zent'
}, _temp2);
exports['default'] = Alert;
module.exports = exports['default'];