'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _PanelCell = require('../common/PanelCell');

var _PanelCell2 = _interopRequireDefault(_PanelCell);

var _utils = require('../utils/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ROW = 4;
var COL = 3;

var MonthPanelBody = function (_Component) {
  _inherits(MonthPanelBody, _Component);

  function MonthPanelBody() {
    _classCallCheck(this, MonthPanelBody);

    return _possibleConstructorReturn(this, (MonthPanelBody.__proto__ || Object.getPrototypeOf(MonthPanelBody)).apply(this, arguments));
  }

  _createClass(MonthPanelBody, [{
    key: 'isSelected',
    value: function isSelected(val) {
      return val === this.props.actived.getMonth();
    }
  }, {
    key: 'getMonths',
    value: function getMonths() {
      var months = [];
      var index = 0;
      for (var rowIndex = 0; rowIndex < ROW; rowIndex++) {
        months[rowIndex] = [];
        for (var colIndex = 0; colIndex < COL; colIndex++) {
          var isCurrent = index === _utils.CURRENT_MONTH;
          var isSelected = this.isSelected(index);
          var className = (0, _classnames2['default'])({
            'panel__cell month-panel__cell': true,
            'panel__cell--current': isCurrent,
            'panel__cell--selected': isSelected
          });
          months[rowIndex][colIndex] = {
            text: index + 1 + '\u6708',
            value: index,
            className: className
          };
          index++;
        }
      }
      return months;
    }
  }, {
    key: 'render',
    value: function render() {
      var months = this.getMonths();
      return _react2['default'].createElement(
        'table',
        { className: 'month-table panel__table' },
        _react2['default'].createElement(_PanelCell2['default'], { onSelect: this.props.onSelect, cells: months })
      );
    }
  }]);

  return MonthPanelBody;
}(_react.Component);

exports['default'] = MonthPanelBody;
module.exports = exports['default'];