'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _PanelHeader = require('../common/PanelHeader');

var _PanelHeader2 = _interopRequireDefault(_PanelHeader);

var _TimeCell = require('./TimeCell');

var _TimeCell2 = _interopRequireDefault(_TimeCell);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ROW = 9;
var COL = 7;

var MinutePanel = function (_Component) {
  _inherits(MinutePanel, _Component);

  function MinutePanel() {
    _classCallCheck(this, MinutePanel);

    return _possibleConstructorReturn(this, (MinutePanel.__proto__ || Object.getPrototypeOf(MinutePanel)).apply(this, arguments));
  }

  _createClass(MinutePanel, [{
    key: 'isDisabled',
    value: function isDisabled(val) {
      var disabledMinute = this.props.disabledMinute;

      if (typeof disabledMinute === 'function') {
        return disabledMinute(val);
      }
    }
  }, {
    key: 'isSelected',
    value: function isSelected(val) {
      var selected = this.props.selected;

      return selected.getMinutes() === val;
    }
  }, {
    key: 'isCurrent',
    value: function isCurrent(val) {
      return _utils.CURRENT.getMinutes() === val;
    }
  }, {
    key: 'getMinutes',
    value: function getMinutes() {
      var cells = [];
      var i = 0;
      for (var j = 0; j < ROW; j++) {
        cells[j] = [];
        for (var k = 0; k < COL && i < 60; k++) {
          var isDisabled = this.isDisabled(i);
          var isSelected = this.isSelected(i);
          var isCurrent = this.isCurrent(i);
          var className = (0, _classnames2['default'])({
            'panel__cell time-panel__cell': true,
            'panel__cell--disabled': isDisabled,
            'panel__cell--selected': isSelected,
            'panel__cell--current': isCurrent
          });
          cells[j][k] = {
            text: (0, _utils.padLeft)(i),
            value: i,
            isDisabled: isDisabled,
            className: className
          };
          i++;
        }
      }
      return cells;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var minutes = this.getMinutes();
      var title = '选择分钟';
      return _react2['default'].createElement(
        'div',
        { className: 'minute-panel' },
        _react2['default'].createElement(_PanelHeader2['default'], { title: title, showNext: false, prev: function prev() {
            _this2.props.hidePanel('minute');
          } }),
        _react2['default'].createElement(
          'table',
          { className: 'minute-table panel__table' },
          _react2['default'].createElement(_TimeCell2['default'], { cells: minutes, onSelect: this.props.onSelect })
        )
      );
    }
  }]);

  return MinutePanel;
}(_react.Component);

exports['default'] = MinutePanel;
module.exports = exports['default'];