'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils/');

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _PanelCell = require('../common/PanelCell');

var _PanelCell2 = _interopRequireDefault(_PanelCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ROW = 4;
var COL = 3;

var YearPanelBody = function (_Component) {
  _inherits(YearPanelBody, _Component);

  function YearPanelBody() {
    _classCallCheck(this, YearPanelBody);

    return _possibleConstructorReturn(this, (YearPanelBody.__proto__ || Object.getPrototypeOf(YearPanelBody)).apply(this, arguments));
  }

  _createClass(YearPanelBody, [{
    key: 'isSelected',
    value: function isSelected(val) {
      return this.props.actived.getFullYear() === val;
    }
  }, {
    key: 'getYears',
    value: function getYears() {
      var years = [];
      var index = 0;
      var actived = this.props.actived;
      var beginYear = actived.getFullYear() - 4;
      for (var rowIndex = 0; rowIndex < ROW; rowIndex++) {
        years[rowIndex] = [];
        for (var colIndex = 0; colIndex < COL; colIndex++) {
          var val = beginYear + index;
          var isCurrent = val === _utils.CURRENT_YEAR;
          var isSelected = this.isSelected(val);
          var className = (0, _classnames2['default'])({
            'year-panel__cell panel__cell': true,
            'panel__cell--current': isCurrent,
            'panel__cell--selected': isSelected
          });
          years[rowIndex][colIndex] = {
            text: val,
            value: val,
            className: className
          };
          index++;
        }
      }
      return years;
    }
  }, {
    key: 'render',
    value: function render() {
      var years = this.getYears();
      return _react2['default'].createElement(
        'table',
        { className: 'year-table panel__table' },
        _react2['default'].createElement(_PanelCell2['default'], { onSelect: this.props.onSelect, cells: years })
      );
    }
  }]);

  return YearPanelBody;
}(_react.Component);

exports['default'] = YearPanelBody;
module.exports = exports['default'];