'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

exports['default'] = function (Control) {
  return function (_ref) {
    var _ref$required = _ref.required,
        required = _ref$required === undefined ? false : _ref$required,
        _ref$helpDesc = _ref.helpDesc,
        helpDesc = _ref$helpDesc === undefined ? '' : _ref$helpDesc,
        props = _objectWithoutProperties(_ref, ['required', 'helpDesc']);

    var showError = props.isTouched && props.error;
    var className = (0, _classnames2['default'])({
      'zent-form__control-group': true,
      'has-error': showError
    });

    return _react2['default'].createElement(
      'div',
      { className: className },
      _react2['default'].createElement(
        'label',
        { className: 'zent-form__control-label' },
        required ? _react2['default'].createElement(
          'em',
          { className: 'zent-form__required' },
          '*'
        ) : null,
        props.label
      ),
      _react2['default'].createElement(
        'div',
        { className: 'zent-form__controls' },
        _react2['default'].createElement(Control, props),
        helpDesc && _react2['default'].createElement(
          'p',
          { className: 'zent-form__help-desc' },
          helpDesc
        ),
        showError && _react2['default'].createElement(
          'p',
          { className: 'zent-form__help-block' },
          props.error
        )
      )
    );
  };
};

module.exports = exports['default'];