'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('zent-utils/lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Input(props) {
  var _classNames;

  var handleKeyDown = function handleKeyDown(evt) {
    var onKeyDown = props.onKeyDown,
        onPressEnter = props.onPressEnter;

    if (onPressEnter && evt.keyCode === 13) {
      onPressEnter(evt);
    }

    if (onKeyDown) onKeyDown(evt);
  };

  var addonBefore = props.addonBefore,
      addonAfter = props.addonAfter,
      prefix = props.prefix,
      className = props.className;


  var wrapClass = (0, _classnames2['default'])((_classNames = {}, _defineProperty(_classNames, prefix + '-input-wrapper', true), _defineProperty(_classNames, prefix + '-input-addons', props.addonAfter || props.addonBefore), _classNames), className);

  // 黑名单，下面这些props不应该带入到Input上
  var inputProps = (0, _omit2['default'])(props, ['className', 'prefix']);

  return _react2['default'].createElement(
    'div',
    { className: wrapClass },
    addonBefore && _react2['default'].createElement(
      'span',
      { className: prefix + '-input-addon-before' },
      addonBefore
    ),
    _react2['default'].createElement('input', _extends({ className: prefix + '-input' }, inputProps, { onKeyDown: handleKeyDown })),
    addonAfter && _react2['default'].createElement(
      'span',
      { className: prefix + '-input-addon-after' },
      addonAfter
    )
  );
}

Input.defaultProps = {
  disabled: false,
  readOnly: false,
  prefix: 'zent'
};

Input.propTypes = {
  className: _react2['default'].PropTypes.string,
  prefix: _react2['default'].PropTypes.string,
  type: _react2['default'].PropTypes.string,
  placeholder: _react2['default'].PropTypes.string,
  disabled: _react2['default'].PropTypes.bool,
  readOnly: _react2['default'].PropTypes.bool,
  value: _react2['default'].PropTypes.any,
  defaultValue: _react2['default'].PropTypes.any,
  addonBefore: _react2['default'].PropTypes.node,
  addonAfter: _react2['default'].PropTypes.node,
  onPressEnter: _react2['default'].PropTypes.func,
  onChange: _react2['default'].PropTypes.func
};

exports['default'] = Input;
module.exports = exports['default'];