'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _React$PropTypes = _react2['default'].PropTypes,
    string = _React$PropTypes.string,
    number = _React$PropTypes.number,
    func = _React$PropTypes.func,
    bool = _React$PropTypes.bool;


var Pager = _react2['default'].createClass({
  displayName: 'Pager',

  propTypes: {
    content: string,
    current: bool,
    onClick: func,
    target: number
  },

  getInitialState: function getInitialState() {
    return {
      pageLabel: this.props.content
    };
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    this.setState({
      pageLabel: nextProps.content
    });
  },
  onClick: function onClick() {
    // 有目标，且不是当前页的时候
    if (this.props.target && !this.props.current) {
      this.props.onChange(this.props.target);
    }
  },
  render: function render() {
    var className = 'pager';

    if (this.props.current) {
      className += ' pager--current';
    }

    if (this.props.type === 'omni') {
      className += ' pager--omni';
    } else {
      if (!this.props.target) {
        className += ' pager--disabled';
      }
    }

    return _react2['default'].createElement(
      'li',
      {
        className: className,
        onClick: this.onClick },
      this.props.content
    );
  }
});

exports['default'] = Pager;
module.exports = exports['default'];