'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = exports.PopoverContextType = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp; /**
                    * 设计：
                    *
                    * Popover组件只是一个壳子，负责组装Trigger和Content。
                    *
                    * 弹层实际的打开／关闭都是Content完成的，而什么情况打开弹层是Trigger控制的。
                    */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _noop = require('zent-utils/lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _uniqueId = require('zent-utils/lodash/uniqueId');

var _uniqueId2 = _interopRequireDefault(_uniqueId);

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

var _Trigger = require('./trigger/Trigger');

var _Trigger2 = _interopRequireDefault(_Trigger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function instanceOf(MaybeDerive, Base) {
  return MaybeDerive === Base || MaybeDerive.prototype instanceof Base;
}

var PopoverContextType = exports.PopoverContextType = {
  popover: _react.PropTypes.shape({
    close: _react.PropTypes.func.isRequired,
    open: _react.PropTypes.func.isRequired,
    getContentNode: _react.PropTypes.func.isRequired,
    getTriggerNode: _react.PropTypes.func.isRequired
  })
};

var Popover = (_temp = _class = function (_Component) {
  _inherits(Popover, _Component);

  _createClass(Popover, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        popover: {
          close: this.close,
          open: this.open,
          getContentNode: this.getPopoverNode,
          getTriggerNode: this.getTriggerNode
        }
      };
    }
  }]);

  function Popover(props) {
    _classCallCheck(this, Popover);

    // id用来唯一标识popover实例
    var _this = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

    _this.state = {
      visible: false
    };

    _this.getPopoverNode = function () {
      return document.querySelector('.' + _this.id);
    };

    _this.onTriggerRefChange = function (triggerInstance) {
      _this.triggerNode = _reactDom2['default'].findDOMNode(triggerInstance);
    };

    _this.getTriggerNode = function () {
      return _this.triggerNode;
    };

    _this.open = function () {
      _this.props.onBeforeShow();

      _this.setState({
        visible: true
      }, _this.props.onShow);
    };

    _this.close = function () {
      _this.props.onBeforeClose();

      _this.setState({
        visible: false
      }, _this.props.onClose);
    };

    _this.id = (0, _uniqueId2['default'])(props.prefix + '-popover-internal-id-');
    return _this;
  }

  _createClass(Popover, [{
    key: 'validateChildren',
    value: function validateChildren() {
      var children = this.props.children;

      var childArray = _react.Children.toArray(children);

      if (childArray.length !== 2) {
        throw new Error('There must be one and only one trigger and content in Popover');
      }

      var _childArray$reduce = childArray.reduce(function (state, c) {
        var type = c.type;
        if (instanceOf(type, _Trigger2['default'])) {
          state.trigger = c;
        } else if (instanceOf(type, _Content2['default'])) {
          state.content = c;
        }

        return state;
      }, { trigger: null, content: null }),
          trigger = _childArray$reduce.trigger,
          content = _childArray$reduce.content;

      if (!trigger) {
        throw new Error('Missing trigger in Popover');
      }
      if (!content) {
        throw new Error('Missing content in Popover');
      }

      return { trigger: trigger, content: content };
    }
  }, {
    key: 'render',
    value: function render() {
      var _validateChildren = this.validateChildren(),
          trigger = _validateChildren.trigger,
          content = _validateChildren.content;

      var _props = this.props,
          display = _props.display,
          prefix = _props.prefix,
          className = _props.className,
          containerSelector = _props.containerSelector,
          position = _props.position,
          cushion = _props.cushion;
      var visible = this.state.visible;


      return _react2['default'].createElement(
        'div',
        { style: { display: display }, className: (0, _classnames2['default'])(prefix + '-popover-wrapper', className && className + '-wrapper') },
        _react2['default'].cloneElement(trigger, {
          prefix: prefix,
          contentVisible: visible,
          onTriggerRefChange: this.onTriggerRefChange,
          getTriggerNode: this.getTriggerNode,
          getContentNode: this.getPopoverNode,
          open: this.open,
          close: this.close
        }),
        _react2['default'].cloneElement(content, {
          prefix: prefix,
          className: className,
          id: this.id,
          getContentNode: this.getPopoverNode,
          getAnchor: this.getTriggerNode,
          visible: visible,
          cushion: cushion,
          containerSelector: containerSelector,
          placement: position
        })
      );
    }
  }]);

  return Popover;
}(_react.Component), _class.propTypes = {
  prefix: _react.PropTypes.string,
  className: _react.PropTypes.string,

  // container的display属性
  display: _react.PropTypes.string,

  // position strategy
  position: _react.PropTypes.func.isRequired,

  // 定位时的偏移量
  cushion: _react.PropTypes.number,

  onBeforeClose: _react.PropTypes.func,
  onBeforeShow: _react.PropTypes.func,
  onClose: _react.PropTypes.func,
  onShow: _react.PropTypes.func,

  // defaults to body
  containerSelector: _react.PropTypes.string,

  children: _react.PropTypes.node.isRequired
}, _class.defaultProps = {
  prefix: 'zent',
  className: '',
  display: 'block',
  onBeforeClose: _noop2['default'],
  onBeforeShow: _noop2['default'],
  onClose: _noop2['default'],
  onShow: _noop2['default'],
  cushion: 0,
  containerSelector: 'body'
}, _class.childContextTypes = PopoverContextType, _temp);
exports['default'] = Popover;