'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports['default'] = withESCToClose;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _omit = require('zent-utils/lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
  Not exported in index.js.

  Provides an HOC component for ESC to close functionality, useful in some cases.
**/
function withESCToClose(Closable) {
  var _class, _temp2;

  return _temp2 = _class = function (_Component) {
    _inherits(ESCToCloseWrapper, _Component);

    function ESCToCloseWrapper() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, ESCToCloseWrapper);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ESCToCloseWrapper.__proto__ || Object.getPrototypeOf(ESCToCloseWrapper)).call.apply(_ref, [this].concat(args))), _this), _this.onKeyUp = function (evt) {
        if (evt.keyCode === 27) {
          _this.props.onClose();
        }
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(ESCToCloseWrapper, [{
      key: 'on',
      value: function on() {
        document.body.addEventListener('keyup', this.onKeyUp, true);
      }
    }, {
      key: 'off',
      value: function off() {
        document.body.removeEventListener('keyup', this.onKeyUp, true);
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.props.visible) {
          this.on();
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (this.props.visible) {
          this.off();
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.visible !== this.props.visible) {
          if (nextProps.visible) {
            this.on();
          } else {
            this.off();
          }
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var props = (0, _omit2['default'])(this.props, ['onClose']);
        return _react2['default'].createElement(Closable, props);
      }
    }]);

    return ESCToCloseWrapper;
  }(_react.Component), _class.propTypes = {
    visible: _react.PropTypes.bool.isRequired,
    onClose: _react.PropTypes.func.isRequired
  }, _temp2;
}
module.exports = exports['default'];