'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _assign = require('zent-utils/lodash/assign');

var _assign2 = _interopRequireDefault(_assign);

var _Tag = require('../components/Tag');

var _Tag2 = _interopRequireDefault(_Tag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * TagsTrigger
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var noop = function noop() {};

var TagsTrigger = function (_Component) {
  _inherits(TagsTrigger, _Component);

  function TagsTrigger(props) {
    _classCallCheck(this, TagsTrigger);

    var _this = _possibleConstructorReturn(this, (TagsTrigger.__proto__ || Object.getPrototypeOf(TagsTrigger)).call(this, props));

    _this.state = (0, _assign2['default'])({}, props);
    _this.deleteTagHandler = _this.deleteTagHandler.bind(_this);
    return _this;
  }

  _createClass(TagsTrigger, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var selectedItems = this.state.selectedItems;
      var cid = nextProps.cid,
          text = nextProps.text,
          value = nextProps.value;


      if (this.isDelete || this.isAdded) {
        this.isDelete = false;
        this.isAdded = false;
        return;
      }

      var isExist = selectedItems.filter(function (item) {
        return item.cid === cid;
      }).length > 0;

      if (nextProps.selectedItems) {
        this.state.selectedItems = nextProps.selectedItems;
      }

      if (typeof cid !== 'undefined' && !isExist) {
        selectedItems.push({
          cid: cid,
          text: text,
          value: value
        });
        this.props.onChange({
          selectedItems: selectedItems,
          selectedItem: {
            value: ''
          },
          open: false
        });
      } else if (isExist) {
        this.isAdded = true;
        this.props.onChange({
          selectedItem: {
            value: ''
          }
        });
      }
    }
  }, {
    key: 'deleteTagHandler',
    value: function deleteTagHandler(cid) {
      var selectedItems = this.state.selectedItems;

      var deleteItem = selectedItems.filter(function (item) {
        return item.cid === cid;
      })[0];
      selectedItems = selectedItems.filter(function (item) {
        return item.cid !== cid;
      });
      this.isDelete = true;
      this.setState({
        selectedItems: selectedItems
      });
      this.props.onDelete(deleteItem);
      this.props.onChange({
        selectedItems: selectedItems,
        selectedItem: {},
        open: false
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          prefixCls = _props.prefixCls,
          placeholder = _props.placeholder,
          onClick = _props.onClick;
      var selectedItems = this.state.selectedItems;


      return _react2['default'].createElement(
        'div',
        { className: prefixCls + '-tags', onClick: onClick },
        selectedItems.length > 0 ? selectedItems.map(function (item) {
          return _react2['default'].createElement(_Tag2['default'], _extends({}, _this2.props, {
            key: item.cid,
            cid: item.cid
          }, item, {
            onDelete: _this2.deleteTagHandler
          }));
        }) : placeholder
      );
    }
  }]);

  return TagsTrigger;
}(_react.Component);

TagsTrigger.propTypes = {
  prefixCls: _react.PropTypes.string,
  selectedItems: _react.PropTypes.array,
  selectedItem: _react.PropTypes.object,
  placeholder: _react.PropTypes.string,
  value: _react.PropTypes.any,
  onDelete: _react.PropTypes.func
};

TagsTrigger.defaultProps = {
  selectedItems: [],
  onDelete: noop
};

exports['default'] = TagsTrigger;
module.exports = exports['default'];