'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _zentIcon = require('zent-icon');

var _zentIcon2 = _interopRequireDefault(_zentIcon);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Step = function (_Component) {
  _inherits(Step, _Component);

  function Step() {
    _classCallCheck(this, Step);

    return _possibleConstructorReturn(this, (Step.__proto__ || Object.getPrototypeOf(Step)).apply(this, arguments));
  }

  _createClass(Step, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var props = this.props;

      var prefix = props.prefix,
          tailWidth = props.tailWidth,
          isCurrentStep = props.isCurrentStep,
          _props$status = props.status,
          status = _props$status === undefined ? 'wait' : _props$status,
          isLastFinishStep = props.isLastFinishStep,
          adjustMarginRight = props.adjustMarginRight,
          stepLast = props.stepLast,
          stepNumber = props.stepNumber,
          title = props.title,
          description = props.description;


      var iconNode = void 0;

      if ((status === 'finish' || status === 'error') && (!isCurrentStep || !isLastFinishStep)) {
        if (status === 'finish') {
          iconNode = _react2['default'].createElement(_zentIcon2['default'], { type: 'check-circle' });
        } else {
          iconNode = _react2['default'].createElement(_zentIcon2['default'], { type: 'error-circle' });
        }
      } else {
        iconNode = _react2['default'].createElement(
          'span',
          { className: prefix + '-icon' },
          stepNumber
        );
      }

      var classString = (0, _classnames2['default'])((_classNames = {}, _defineProperty(_classNames, prefix + '-steps-item', true), _defineProperty(_classNames, prefix + '-steps-status-finish', status === 'finish'), _defineProperty(_classNames, prefix + '-steps-status-error', status === 'error'), _defineProperty(_classNames, 'is-current', isCurrentStep), _defineProperty(_classNames, 'is-last-finish', isLastFinishStep), _classNames));

      return _react2['default'].createElement(
        'div',
        {
          className: classString,
          style: { width: tailWidth, marginRight: adjustMarginRight }
        },
        stepLast ? '' : _react2['default'].createElement(
          'div',
          { className: prefix + '-steps-tail' },
          _react2['default'].createElement('i', null)
        ),
        _react2['default'].createElement(
          'div',
          { className: prefix + '-steps-step' },
          _react2['default'].createElement(
            'div',
            { className: prefix + '-step-head' },
            _react2['default'].createElement(
              'div',
              { className: prefix + '-step-head-inner' },
              iconNode
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: prefix + '-step-main' },
            _react2['default'].createElement(
              'div',
              { className: prefix + '-step-title' },
              title
            ),
            description ? _react2['default'].createElement(
              'div',
              { className: prefix + '-step-description' },
              description
            ) : ''
          )
        )
      );
    }
  }]);

  return Step;
}(_react.Component);

exports['default'] = Step;


Step.propTypes = {
  prefix: _react.PropTypes.string,
  style: _react.PropTypes.object,
  wrapperStyle: _react.PropTypes.object,
  tailWidth: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  adjustMarginRight: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  stepLast: _react.PropTypes.bool,
  isCurrentStep: _react.PropTypes.bool,
  isLastFinishStep: _react.PropTypes.bool,
  stepNumber: _react.PropTypes.string,
  status: _react.PropTypes.string,
  title: _react.PropTypes.node.isRequired,
  description: _react.PropTypes.node
};
module.exports = exports['default'];