'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2; /* eslint-disable no-underscore-dangle */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getViewportSize = require('../dom/getViewportSize');

var _getViewportSize2 = _interopRequireDefault(_getViewportSize);

var _WindowEventHandler = require('./WindowEventHandler');

var _WindowEventHandler2 = _interopRequireDefault(_WindowEventHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Handles window.resize event.
 *
 * The event handler got a second parameter: {deltaX, deltaY}.
 * The resize event handler should be throttled since resize events can fire at a high rate.
 */
var WindowResizeHandler = (_temp2 = _class = function (_Component) {
  _inherits(WindowResizeHandler, _Component);

  function WindowResizeHandler() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, WindowResizeHandler);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WindowResizeHandler.__proto__ || Object.getPrototypeOf(WindowResizeHandler)).call.apply(_ref, [this].concat(args))), _this), _this.onResize = function (evt) {
      var viewportSize = (0, _getViewportSize2['default'])();
      var prevViewportSize = _this._prevViewportSize;
      var delta = {
        deltaX: viewportSize.width - prevViewportSize.width,
        deltaY: viewportSize.height - prevViewportSize.height
      };

      if (delta.deltaX === 0 && delta.deltaY === 0) {
        return;
      }

      _this.props.onResize(evt, delta);
      _this._prevViewportSize = viewportSize;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(WindowResizeHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._prevViewportSize = (0, _getViewportSize2['default'])();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(_WindowEventHandler2['default'], { eventName: 'resize', callback: this.onResize });
    }
  }]);

  return WindowResizeHandler;
}(_react.Component), _class.propTypes = {
  onResize: _react.PropTypes.func.isRequired
}, _temp2);
exports['default'] = WindowResizeHandler;
module.exports = exports['default'];